<?php

/**
 * @file
 * Preprocessors and helper functions to make theming easier.
 */
use Drupal\Core\Template\Attribute;
use Drupal\Component\Utility\Html;
use Drupal\views\ViewExecutable;
/**
 * Prepares variables for views grid templates.
 *
 * Default template:slickanimate.html.twig.
 *
 * @param array $vars
 *   An associative array containing:
 *   - view: A ViewExecutable object.
 *   - rows: The raw row data.
 */
function template_preprocess_views_view_slickanimate(array &$vars) {
  $view = $vars['view'];
  $vars['id'] = getUniqueId($view);

  $options = $view->style_plugin->options;

  $slickSlideImage = $view->style_plugin->options['views_slick_settings']['animationModel']['slickSlideImage'];
  $imageAnimation = $view->style_plugin->options['views_slick_settings']['animationModel']['imageAnimationType'];
  $slickSlideTitle = $view->style_plugin->options['views_slick_settings']['animationModel']['slickSlideTitle'];
  $titleAnimation = $view->style_plugin->options['views_slick_settings']['animationModel']['titleAnimationType'];
  $slickSlideSubtitle = $view->style_plugin->options['views_slick_settings']['animationModel']['slickSlideSubtitle'];
  $subTitleAnimation = $view->style_plugin->options['views_slick_settings']['animationModel']['subTitleAnimationType'];
  $slickSlideDescription = $view->style_plugin->options['views_slick_settings']['animationModel']['slickSlideDescription'];
  $descriptionAnimation = $view->style_plugin->options['views_slick_settings']['animationModel']['descriptionAnimationType'];
  $slidebutton = $view->style_plugin->options['views_slick_settings']['animationModel']['slickSlideButton'];

  // multiple animate make auto
  $rendomanimate = $view->style_plugin->options['views_slick_settings']['animationModel']['rendomAnimate'];
  $multipleanimate = $view->style_plugin->options['views_slick_settings']['animationModel']['multipleAnimates'];
    $animateConut = 0;
    $animateautoimg = 0;
    $getAnimates = array_keys($multipleanimate);
  foreach ($vars['rows'] as $id => $row) {
    if (count($getAnimates) == $animateConut) { $animateConut = 0; }
    if ($animateautoimg == 2) { $animateautoimg = 0; }
    $vars['rows'][$id]['slickslideimage'] = $view->style_plugin->getField($id, $slickSlideImage);
    $vars['rows'][$id]['imageanimation'] = ($rendomanimate == 0) ? $imageAnimation : ["zoomInImage","zoomOutImage"][$animateautoimg];
    $vars['rows'][$id]['slickslidetitle'] = $view->style_plugin->getField($id, $slickSlideTitle);
    $vars['rows'][$id]['titleanimation'] = ($rendomanimate == 0) ? $titleAnimation : $getAnimates[$animateConut];
    $vars['rows'][$id]['slickslidesubtitle'] = $view->style_plugin->getField($id, $slickSlideSubtitle);
    $vars['rows'][$id]['subTitleanimation'] = ($rendomanimate == 0) ? $subTitleAnimation : $getAnimates[$animateConut];
    $vars['rows'][$id]['slickslidedescription'] = $view->style_plugin->getField($id, $slickSlideDescription);
    $vars['rows'][$id]['descriptionanimation'] = ($rendomanimate == 0) ? $descriptionAnimation : $getAnimates[$animateConut];
    $vars['rows'][$id]['slidebutton'] = $view->style_plugin->getField($id, $slidebutton);
    // auto count plus
    $animateConut++;
    $animateautoimg++;
  }
  
  $vars['slick_styles'] = $options["views_slick_settings"]['styles'];
  $vars['modelview'] = $options['views_slick_settings']['animationModel']['modelView'];
  $vars['animate_make'] = $options['views_slick_settings']['animationModel']['checkForAnimate'];
  $vars['autoanimate'] = $rendomanimate;
  
  $vars['#attached']['library'][] = 'views_slick_animate/slickanimatesettings';
  $options['views_slick_settings']['id'] = $vars['id'];
  $vars['#attached']['drupalSettings']['views_slick_animate']['slick_setting'] = $options['views_slick_settings'];

  $vars['options'] = $options;
}

function getUniqueId(ViewExecutable $view) {
  $id = $view->storage->id() . '-' . $view->current_display;
  return Html::getUniqueId('slickanimate-' . $id);
}